(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
(*import packages*)
SetDirectory[ParentDirectory[NotebookDirectory[]]];
(*for functions such as addToGlobalAssumptions, findCommonFactor*)
<<useful_functions.m
(*for non-commutative operator algebra*)
<<JoeMatica_OperatorAlgebraNew.m

(*tiny constant for plotting*)
\[Epsilon]=1. 10^-5;


(* ::Input::Initialization:: *)
addToGlobalAssumptions[{0<=\[Mu]<=1,r\[Element]Reals}];

listThatCommute[{\!\(\*OverscriptBox[\(id\), \(^\)]\),\!\(\*OverscriptBox[\(a\), \(^\)]\),SuperDagger[\!\(\*OverscriptBox[\(a\), \(^\)]\)],\!\(\*OverscriptBox[\(b\), \(^\)]\),SuperDagger[\!\(\*OverscriptBox[\(b\), \(^\)]\)]}]
commutator[\!\(\*OverscriptBox[\(a\), \(^\)]\),SuperDagger[\!\(\*OverscriptBox[\(a\), \(^\)]\)],1]
commutator[\!\(\*OverscriptBox[\(b\), \(^\)]\),SuperDagger[\!\(\*OverscriptBox[\(b\), \(^\)]\)],1] 
(*2-mode vacuum state, this is a little informal, to be fully correct would need JoeMatica to work with TensorProduct directly esc<t*>esc*)
contraction[Subscript[\!\(\*OverscriptBox[\(bra\), \(^\)]\), HoldForm[0\[TensorProduct]0]],Subscript[\!\(\*OverscriptBox[\(ket\), \(^\)]\), HoldForm[0\[TensorProduct]0]],1]
contraction[\!\(\*OverscriptBox[\(a\), \(^\)]\),Subscript[\!\(\*OverscriptBox[\(ket\), \(^\)]\), HoldForm[0\[TensorProduct]0]],0]
contraction[\!\(\*OverscriptBox[\(b\), \(^\)]\),Subscript[\!\(\*OverscriptBox[\(ket\), \(^\)]\), HoldForm[0\[TensorProduct]0]],0]
contraction[\!\(\*OverscriptBox[\(id\), \(^\)]\),Subscript[\!\(\*OverscriptBox[\(ket\), \(^\)]\), HoldForm[0\[TensorProduct]0]],Subscript[\!\(\*OverscriptBox[\(ket\), \(^\)]\), HoldForm[0\[TensorProduct]0]]]
(*JoeMatica is not realising that \[LeftAngleBracket]0\[TensorProduct]0|\[SmallCircle]Overscript[b, ^]\[SmallCircle]Overscript[a, ^]^\[Dagger]\[SmallCircle]|0\[TensorProduct]0\[RightAngleBracket]=0, is there a good way to tell it to try \[LeftAngleBracket]0\[TensorProduct]0|\[SmallCircle]Overscript[a, ^]^\[Dagger]\[SmallCircle]Overscript[b, ^]\[SmallCircle]|0\[TensorProduct]0\[RightAngleBracket]?*)
minimalAlgebraPrompt={If[co[\!\(\*OverscriptBox[\(b\), \(^\)]\),SuperDagger[\!\(\*OverscriptBox[\(a\), \(^\)]\)]]==0,Bra[\!\(
TagBox[
RowBox[{"0", "\[TensorProduct]", "0"}],
HoldForm]\)]\[SmallCircle]\!\(\*OverscriptBox[\(b\), \(^\)]\)\[SmallCircle]SuperDagger[\!\(\*OverscriptBox[\(a\), \(^\)]\)]\[SmallCircle]Ket[\!\(
TagBox[
RowBox[{"0", "\[TensorProduct]", "0"}],
HoldForm]\)]->Bra[\!\(
TagBox[
RowBox[{"0", "\[TensorProduct]", "0"}],
HoldForm]\)]\[SmallCircle]SuperDagger[\!\(\*OverscriptBox[\(a\), \(^\)]\)]\[SmallCircle](\!\(\*OverscriptBox[\(b\), \(^\)]\)\[SmallCircle]Ket[\!\(
TagBox[
RowBox[{"0", "\[TensorProduct]", "0"}],
HoldForm]\)]),Throw["minimalAlgebraPrompt: Algebra error."]]};

\!\(\*OverscriptBox[\(x1\), \(^\)]\)=1/Sqrt[2] (\!\(\*OverscriptBox[\(a\), \(^\)]\)+SuperDagger[\!\(\*OverscriptBox[\(a\), \(^\)]\)]);
\!\(\*OverscriptBox[\(x2\), \(^\)]\)=1/Sqrt[2] (\!\(\*OverscriptBox[\(b\), \(^\)]\)+SuperDagger[\!\(\*OverscriptBox[\(b\), \(^\)]\)]);
\!\(\*OverscriptBox[\(p1\), \(^\)]\)=1/Sqrt[2] (-I\!\(\*OverscriptBox[\(a\), \(^\)]\)+I SuperDagger[\!\(\*OverscriptBox[\(a\), \(^\)]\)]);
\!\(\*OverscriptBox[\(p2\), \(^\)]\)=1/Sqrt[2] (-I\!\(\*OverscriptBox[\(b\), \(^\)]\)+I SuperDagger[\!\(\*OverscriptBox[\(b\), \(^\)]\)]);
quads={\!\(\*OverscriptBox[\(x1\), \(^\)]\),\!\(\*OverscriptBox[\(p1\), \(^\)]\),\!\(\*OverscriptBox[\(x2\), \(^\)]\),\!\(\*OverscriptBox[\(p2\), \(^\)]\)};

(*defining some that stay in quadrature symbolic form unless replaced*)
listThatCommute[{\!\(\*OverscriptBox[\(X1\), \(^\)]\),\!\(\*OverscriptBox[\(P1\), \(^\)]\),\!\(\*OverscriptBox[\(X2\), \(^\)]\),\!\(\*OverscriptBox[\(P2\), \(^\)]\)}]
commutator[\!\(\*OverscriptBox[\(X1\), \(^\)]\),\!\(\*OverscriptBox[\(P1\), \(^\)]\),I]
commutator[\!\(\*OverscriptBox[\(X2\), \(^\)]\),\!\(\*OverscriptBox[\(P2\), \(^\)]\),I] 
Quads={\!\(\*OverscriptBox[\(X1\), \(^\)]\),\!\(\*OverscriptBox[\(P1\), \(^\)]\),\!\(\*OverscriptBox[\(X2\), \(^\)]\),\!\(\*OverscriptBox[\(P2\), \(^\)]\)};

mapQuadsToLadders={\!\(\*OverscriptBox[\(X1\), \(^\)]\)->\!\(\*OverscriptBox[\(x1\), \(^\)]\),\!\(\*OverscriptBox[\(P1\), \(^\)]\)->\!\(\*OverscriptBox[\(p1\), \(^\)]\),\!\(\*OverscriptBox[\(X2\), \(^\)]\)->\!\(\*OverscriptBox[\(x2\), \(^\)]\),\!\(\*OverscriptBox[\(P2\), \(^\)]\)->\!\(\*OverscriptBox[\(p2\), \(^\)]\)};
mapLaddersToQuads={\!\(\*OverscriptBox[\(a\), \(^\)]\)->1/Sqrt[2] (\!\(\*OverscriptBox[\(X1\), \(^\)]\)+I \!\(\*OverscriptBox[\(P1\), \(^\)]\)),SuperDagger[\!\(\*OverscriptBox[\(a\), \(^\)]\)]->1/Sqrt[2] (\!\(\*OverscriptBox[\(X1\), \(^\)]\)-I \!\(\*OverscriptBox[\(P1\), \(^\)]\)),\!\(\*OverscriptBox[\(b\), \(^\)]\)->1/Sqrt[2] (\!\(\*OverscriptBox[\(X2\), \(^\)]\)+I \!\(\*OverscriptBox[\(P2\), \(^\)]\)),SuperDagger[\!\(\*OverscriptBox[\(b\), \(^\)]\)]->1/Sqrt[2] (\!\(\*OverscriptBox[\(X2\), \(^\)]\)-I \!\(\*OverscriptBox[\(P2\), \(^\)]\))};

iteratedCommutator[obs_,gen_,nMax_:6,mapLaddersToQuadsYes_:True]:=(table=Table[(
tmp =If[n==0,obs,co[gen,tmp]]//FullSimplify;
If[n==0||n==1,1,1/(HoldForm[f!]/.f->n)]tmp
),{n,0,nMax}];If[mapLaddersToQuadsYes,table/.mapLaddersToQuads//FullSimplify,table])
iteratedCommutatorQuads[gen_,nMax_:6]:=Print["Under ",Exp[gen]\[SmallCircle]Subscript[\!\(\*OverscriptBox[\(x\), \(^\)]\), j]\[SmallCircle]Exp[-gen],": ",quads/.mapLaddersToQuads//Simplify//MatrixForm,"->",Table[iteratedCommutator[quads[[k]],gen,nMax],{k,1,4}]//MatrixForm]


(* ::Input::Initialization:: *)
(*iterated commutator series to guess BCH expression. TODO: reuse previous expressions*)
\!\(\*OverscriptBox[\(UBS\), \(^\)]\)=Exp[\[Pi]/4 (SuperDagger[\!\(\*OverscriptBox[\(a\), \(^\)]\)]\[SmallCircle]\!\(\*OverscriptBox[\(b\), \(^\)]\)-\!\(\*OverscriptBox[\(a\), \(^\)]\)\[SmallCircle]SuperDagger[\!\(\*OverscriptBox[\(b\), \(^\)]\)])];
\!\(\*OverscriptBox[\(minusLogUBS\), \(^\)]\)=-(\[Pi]/4)(SuperDagger[\!\(\*OverscriptBox[\(a\), \(^\)]\)]\[SmallCircle]\!\(\*OverscriptBox[\(b\), \(^\)]\)-\!\(\*OverscriptBox[\(a\), \(^\)]\)\[SmallCircle]SuperDagger[\!\(\*OverscriptBox[\(b\), \(^\)]\)]);
(*(Overscript[a, ^]+Overscript[a, ^]^\[Dagger])/Sqrt[2]Table[((-1)^n(\[Pi]/4)^(2n))/(HoldForm[f!]/.{f\[Rule]2n}),{n,0,5}]
(Overscript[b, ^]+Overscript[b, ^]^\[Dagger])/Sqrt[2]Table[((-1)^n(\[Pi]/4)^(2n+1))/(HoldForm[f!]/.{f\[Rule]2n+1}),{n,0,5}]*)
(*regonise as +/- cos(\[Pi]/4) and sin(\[Pi]/4) series*)

(*one-mode squeeze operator for system 1*)
\!\(\*OverscriptBox[\(S1sys1\), \(^\)]\)=Exp[r/2 (\!\(\*OverscriptBox[\(a\), \(^\)]\)\[SmallCircle]\!\(\*OverscriptBox[\(a\), \(^\)]\)-SuperDagger[\!\(\*OverscriptBox[\(a\), \(^\)]\)]\[SmallCircle]SuperDagger[\!\(\*OverscriptBox[\(a\), \(^\)]\)])];
minusLogS1sys1=-(r/2)(\!\(\*OverscriptBox[\(a\), \(^\)]\)\[SmallCircle]\!\(\*OverscriptBox[\(a\), \(^\)]\)-SuperDagger[\!\(\*OverscriptBox[\(a\), \(^\)]\)]\[SmallCircle]SuperDagger[\!\(\*OverscriptBox[\(a\), \(^\)]\)]);
(*recognise exp(-/+ r) series, i.e. Overscript[x1, ^]\[Rule]\[ExponentialE]^-rOverscript[x1, ^], Overscript[p1, ^]\[Rule]\[ExponentialE]^rOverscript[p1, ^]*)
 
(*two-mode squeeze operator*)
\!\(\*OverscriptBox[\(S2\), \(^\)]\)=Exp[r(\!\(\*OverscriptBox[\(a\), \(^\)]\)\[SmallCircle]\!\(\*OverscriptBox[\(b\), \(^\)]\)-SuperDagger[\!\(\*OverscriptBox[\(a\), \(^\)]\)]\[SmallCircle]SuperDagger[\!\(\*OverscriptBox[\(b\), \(^\)]\)])];
minusLogS2=-r(\!\(\*OverscriptBox[\(a\), \(^\)]\)\[SmallCircle]\!\(\*OverscriptBox[\(b\), \(^\)]\)-SuperDagger[\!\(\*OverscriptBox[\(a\), \(^\)]\)]\[SmallCircle]SuperDagger[\!\(\*OverscriptBox[\(b\), \(^\)]\)]);
(*recognise +/- cosh(r) and sinh(r) series*)

(*
iteratedCommutatorQuads[Overscript[minusLogUBS, ^]]
teratedCommutatorQuads[minusLogS1sys1]
iteratedCommutatorQuads[minusLogS2]
*)


(* ::Input::Initialization:: *)
(*putting all the transformations together*)
idAndQuadsAsLadders=Join[{\!\(\*OverscriptBox[\(id\), \(^\)]\)},quads];
idAndQuads=Join[{\!\(\*OverscriptBox[\(id\), \(^\)]\)},quads/.mapLaddersToQuads//Simplify];
(*construct matrices representing each transformation*)
r[z4x1vec_]:=Join[{0},z4x1vec].idAndQuads
printCoeffsidAndQuads[coeffs_]:=Print[coeffs//FullSimplify//TrigToExp//FullSimplify//MatrixForm,".",idAndQuads//MatrixForm]

rvec=Coefficient[r[{y1,x1,y2,x2}],idAndQuads];
(*
Print[r[{y1,x1,y2,x2}]," = "]
printCoeffsidAndQuads[rvec]
*)

printActionOnRvec[matrix_]:=Print[rvec//FullSimplify//TrigToExp//FullSimplify//MatrixForm,".",idAndQuads//MatrixForm,"->",matrix.rvec//FullSimplify//TrigToExp//FullSimplify//MatrixForm,".",idAndQuads//MatrixForm]


(* ::Input::Initialization:: *)
MUBS=({
 {1, 0, 0, 0, 0},
 {0, 1/Sqrt[2], 0, -(1/Sqrt[2]), 0},
 {0, 0, 1/Sqrt[2], 0, -(1/Sqrt[2])},
 {0, 1/Sqrt[2], 0, 1/Sqrt[2], 0},
 {0, 0, 1/Sqrt[2], 0, 1/Sqrt[2]}
});
addToGlobalAssumptions[{\[Theta]1\[Element]Reals,\[Theta]2\[Element]Reals,0<=\[Mu]<=1}];
\[Theta]vec={\[Theta]1,\[Theta]2};
MD1=({
 {1, \[Theta]1, \[Theta]2 \[Mu], \[Theta]2 Sqrt[1-\[Mu]^2], 0},
 {0, 1, 0, 0, 0},
 {0, 0, 1, 0, 0},
 {0, 0, 0, 1, 0},
 {0, 0, 0, 0, 1}
});
MS2=({
 {1, 0, 0, 0, 0},
 {0, Cosh[r], 0, -Sinh[r], 0},
 {0, 0, Cosh[r], 0, Sinh[r]},
 {0, -Sinh[r], 0, Cosh[r], 0},
 {0, 0, Sinh[r], 0, Cosh[r]}
});
MU=MS2.MD1.MUBS//FullSimplify//TrigToExp//FullSimplify;

(*result: how to evolve quadratures*)
evolveQuadsUnderU=Table[Quads[[n]]->Join[{1},Quads].(MU[[;;,n+1]])//FullSimplify,{n,1,4}];
evolveQuadsUnderD1=Table[Quads[[n]]->Join[{1},Quads].(MD1[[;;,n+1]])//FullSimplify,{n,1,4}];

EVOperatorUnderUnitary[operator_,evolveQuadsUnderUnitary_]:=(
(*evolve the covariance using the result that the evolved product is the product of the evolved for Heisenberg operators. Convert to ladders to compute VEV of the evolved product.*)
evolvedOperator=((operator/.evolveQuadsUnderUnitary)/.mapQuadsToLadders);
EV=(Bra[\!\(
TagBox[
RowBox[{"0", "\[TensorProduct]", "0"}],
HoldForm]\)]\[SmallCircle]evolvedOperator\[SmallCircle]Ket[\!\(
TagBox[
RowBox[{"0", "\[TensorProduct]", "0"}],
HoldForm]\)]/.minimalAlgebraPrompt)(*sometimes on import the meaning of the vacuum is lost*)/.TagBox[RowBox[{"0","\[TensorProduct]","0"}],HoldForm]->HoldForm[0\[TensorProduct]0]//FullSimplify;
Return[EV];
)
EVofQuadsUnderU[operator_]:=EVOperatorUnderUnitary[operator,evolveQuadsUnderU]
EVofQuadsUnderD1[operator_]:=EVOperatorUnderUnitary[operator,evolveQuadsUnderD1]

(*
printActionOnRvec[MUBS]
printActionOnRvec[MD1]
printActionOnRvec[MS2]
printActionOnRvec[MU]

Print[evolveQuadsUnderU//MatrixForm]
*)


(* ::Input::Initialization:: *)
(*vacuum expectation value of r, i.e. m(zvec)*)
Clear[m]
m[zvec_]:=(
rvec=Coefficient[r[zvec],idAndQuads];
operator=(MU.rvec).idAndQuadsAsLadders;
Bra[\!\(
TagBox[
RowBox[{"0", "\[TensorProduct]", "0"}],
HoldForm]\)]\[SmallCircle]operator\[SmallCircle]Ket[\!\(
TagBox[
RowBox[{"0", "\[TensorProduct]", "0"}],
HoldForm]\)]
)//Collect[#,{\[Theta]1,\[Theta]2},FullSimplify]&

(*
\[LeftAngleBracket]0\[TensorProduct]0|\[SmallCircle]((MS2.MD1.MUBS.rvec).idAndQuadsAsLadders)\[SmallCircle]|0\[TensorProduct]0\[RightAngleBracket]//Collect[#,{\[Theta]1,\[Theta]2},FullSimplify]&
m[{y1,x1,y2,x2}]
(MU.{0,Subscript[c, x1],Subscript[c, p1],Subscript[c, x2],Subscript[c, p2]})[[1]]==\[LeftAngleBracket]0\[TensorProduct]0|\[SmallCircle]((MU.{0,Subscript[c, x1],Subscript[c, p1],Subscript[c, x2],Subscript[c, p2]}).idAndQuadsAsLadders)\[SmallCircle]|0\[TensorProduct]0\[RightAngleBracket]
(*m[zvec]:=((y1-y2) \[Theta]1)/Sqrt[2]+(\[Theta]2 (x1 \[Mu]-x2 \[Mu]+(y1+y2) Sqrt[1-\[Mu]^2]))/Sqrt[2]*)
*)


(* ::Input::Initialization:: *)
\[CapitalDelta]r[zvec_]:=r[zvec]-m[zvec](*JoeMatica is okay without explicit Overscript[1, ^] everywhere*)
(*
\[CapitalDelta]r[{y1,x1,y2,x2}]
*)

Clear[\[Alpha]]
\[Alpha][zvec1_,zvec2_]:=EVofQuadsUnderU[1/2 aco[\[CapitalDelta]r[zvec1],\[CapitalDelta]r[zvec2]]]
(*
\[Alpha][{Subscript[y, 1],Subscript[x, 1],Subscript[y, 2],Subscript[x, 2]},{Subscript[Y, 1],Subscript[X, 1],Subscript[Y, 2],Subscript[X, 2]}]
\[Alpha][{Subscript[y, 1],Subscript[x, 1],Subscript[y, 2],Subscript[x, 2]},{Subscript[y, 1],Subscript[x, 1],Subscript[y, 2],Subscript[x, 2]}]
*)
(*The correlations are like before with \[Mu]=1!*)

(*all quads covariance matrix should just match \[Alpha]*)
\[CapitalDelta]Quads={\[CapitalDelta]r[{1,0,0,0}],\[CapitalDelta]r[{0,1,0,0}],\[CapitalDelta]r[{0,0,1,0}],\[CapitalDelta]r[{0,0,0,1}]};
(*
Table[EVofQuadsUnderU[1/2aco[\[CapitalDelta]Quads[[j]],\[CapitalDelta]Quads[[k]]]],{j,1,4},{k,1,4}]//FullSimplify//MatrixForm
(*without symmetrisation, see correlations which aren't real*)
Table[EVofQuadsUnderU[\[CapitalDelta]Quads[[j]]\[SmallCircle]\[CapitalDelta]Quads[[k]]],{j,1,4},{k,1,4}]//FullSimplify//MatrixForm
*)
